/*
 * Welcome to your app's main JavaScript file!
 *
 * This file will be included onto the page via the importmap() Twig function,
 * which should already be in your base.html.twig.
 */
import 'bootstrap/dist/css/bootstrap.min.css';
import './styles/app.css';
import './styles/modes.css';
import './styles/emoji-footprint.css';

// Import modules
import './theme.js';
import './emoji-footprint.js';
import './modes.js';
import { initNumberInputs } from './numberInputs.js';
import { initRadioState } from './radioState.js';

// Initialize everything when DOM is ready
document.addEventListener('DOMContentLoaded', function() {
    // Initialize radio button state management
    initRadioState();

    // Initialize number inputs on page load
    initNumberInputs();
});