<?php

declare(strict_types=1);

namespace App\Entity;

use App\Repository\PropertyChangeLogRepository;
use Doctrine\ORM\Mapping\Column;
use Doctrine\ORM\Mapping\Entity;
use Doctrine\ORM\Mapping\GeneratedValue;
use DateTimeImmutable;
use Doctrine\ORM\Mapping\Id;
use Doctrine\ORM\Mapping\Table;

#[Entity(repositoryClass: PropertyChangeLogRepository::class)]
#[Table(name: 'property_change_log')]
final class PropertyChangeLog
{
    #[Id]
    #[GeneratedValue]
    #[Column(type: 'integer')]
    private int|null $id = null;
    #[Column(type: 'string', length: 255)]
    private string $propertyName;
    #[Column(type: 'string', length: 255)]
    private string $entityClass;
    #[Column(type: 'integer', nullable: true)]
    private ?int $entityId = null;
    #[Column(type: 'string', length: 255)]
    private string $newValue;
    #[Column(type: 'datetime_immutable')]
    private DateTimeImmutable $changeDate;

    public function __construct()
    {
        $this->changeDate = new DateTimeImmutable();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getPropertyName(): string
    {
        return $this->propertyName;
    }

    public function setPropertyName(string $propertyName): void
    {
        $this->propertyName = $propertyName;
    }

    public function getEntityClass(): string
    {
        return $this->entityClass;
    }

    public function setEntityClass(string $entityClass): void
    {
        $this->entityClass = $entityClass;
    }

    public function getEntityId(): ?int
    {
        return $this->entityId;
    }

    public function setEntityId(?int $entityId): void
    {
        $this->entityId = $entityId;
    }

    public function getNewValue(): string
    {
        return $this->newValue;
    }

    public function setNewValue(string $newValue): void
    {
        $this->newValue = $newValue;
    }

    public function getChangeDate(): DateTimeImmutable
    {
        return $this->changeDate;
    }

    public function setChangeDate(DateTimeImmutable $changeDate): void
    {
        $this->changeDate = $changeDate;
    }
}
